local bs = AceLibrary("Babble-Spell-2.2")
local AceAddon = AceLibrary("AceAddon-2.0")
local Tablet = AceLibrary("Tablet-2.0")

local L = AceLibrary("AceLocale-2.2"):new("Cartographer_Mining")
L:RegisterTranslations("enUS", function() return {
	["Filter"] = true,
	["Filter out minerals"] = true,

  ["Module description"] = "Mining mapnotes for Cartographer (based on PinPoint by Ammo)",
  
	["Select all"] = true,
	["Select none"] = true,
	["Icon alpha"] = true,
	["Alpha transparency of the icon"] = true,
	["Icon size"] = true,
	["Size of the icons on the map"] = true,
	["Show minimap icons"] = true,
	["Show mining icons on the minimap"] = true,

	["Copper"] = true,
	["Tin"] = true,
	["Iron"] = true,
	["Silver"] = true,
	["Gold"] = true,
	["Mithril"] = true,
	["Truesilver"] = true,
	["Thorium"] = true,
	["Rich Thorium"] = true,
	["Dark Iron"] = true,
	["Lesser Bloodstone"] = true,
	["Incendicite"] = true,
	["Indurium"] = true,
	-- tbc
	["Fel Iron"] = true,
	["Adamantite"] = true,
	["Rich Adamantite"] = true,
	["Khorium"] = true,

	["Copper Vein"] = true,
	["Tin Vein"] = true,
	["Iron Deposit"] = true,
	["Silver Vein"] = true,
	["Ooze Covered Silver Vein"] = true,
	["Gold Vein"] = true,
	["Ooze Covered Gold Vein"] = true,
	["Mithril Deposit"] = true,
	["Ooze Covered Mithril Deposit"] = true,
	["Truesilver Deposit"] = true,
	["Ooze Covered Truesilver Deposit"] = true,
	["Small Thorium Vein"] = true,
	["Ooze Covered Thorium Vein"] = true,
	["Hakkari Thorium Vein"] = true,
	["Rich Thorium Vein"] = true,
	["Ooze Covered Rich Thorium Vein"] = true,
	["Dark Iron Deposit"] = true,
	["Lesser Bloodstone Deposit"] = true,
	["Incendicite Mineral Vein"] = true,
	["Indurium Mineral Vein"] = true,
	-- tbc
	["Fel Iron Deposit"] = true,
	["Adamantite Deposit"] = true,
	["Rich Adamantite Deposit"] = true,
	["Khorium Vein"] = true,

} end)

L:RegisterTranslations("deDE", function() return {
	["Filter"] = "Filter",
	["Filter out minerals"] = "Filtere Mineralien",

  ["Module description"] = "Bergbau-Kartennotizen f\195\188r Cartographer (basierend auf PinPoint von Ammo)",
  
	["Select all"] = "Alle ausw\195\164hlen",
	["Select none"] = "Nichts ausw\195\164hlen",

  ["Icon alpha"] = "Transparenz",
	["Alpha transparency of the icon"] = "Transparenz der Symbole.",
	["Icon size"] = "Symbolgr\195\182\195\159e",
	["Size of the icons on the map"] = "Gr\195\182\195\159e der Symbole auf der Weltkarte.",
  
  ["Show minimap icons"] = "Minimap-Symbole anzeigen",
	["Show mining icons on the minimap"] = "Erzsymbole auf der Minimap anzeigen.",

  
	["Copper"] = "Kupfer",
	["Tin"] = "Zinn",
	["Iron"] = "Eisen",
	["Silver"] = "Silber",
	["Gold"] = "Gold",
	["Mithril"] = "Mithril",
	["Truesilver"] = "Echtsilber",
	["Thorium"] = "Thorium",
	["Rich Thorium"] = "Reiches Thorium",
	["Dark Iron"] = "Dunkeleisen",
	["Lesser Bloodstone"] = "Geringer Blutstein",
  ["Incendicite"] = "Pyrophor",
	-- tbc
	["Fel Iron"] = "Teufelseisen",
	["Adamantite"] = "Adamantium",
	["Rich Adamantite"] = "Reiches Adamantium",
	["Khorium"] = "Khorium",

	["Copper Vein"] = "Kupfervorkommen",
	["Tin Vein"] = "Zinnvorkommen",
	["Iron Deposit"] = "Eisenvorkommen",
	["Silver Vein"] = "Silbervorkommen",
	["Ooze Covered Silver Vein"] = "Br\195\188hschlammbedecktes Silbervorkommen",
	["Gold Vein"] = "Goldvorkommen",
	["Ooze Covered Gold Vein"] = "Br\195\188hschlammbedecktes Goldvorkommen",
	["Mithril Deposit"] = "Mithrilablagerung",
	["Ooze Covered Mithril Deposit"] = "Br\195\188hschlammbedeckte Mithrilablagerung",
	["Truesilver Deposit"] = "Echtsilberablagerung",
	["Ooze Covered Truesilver Deposit"] = "Br\195\188hschlammbedeckte Echtsilberablagerung",
	["Small Thorium Vein"] = "Kleines Thoriumvorkommen",
	["Ooze Covered Thorium Vein"] = "Br\195\188hschlammbedecktes Thoriumvorkommen",
	["Hakkari Thorium Vein"] = "Hakkari Thoriumvorkommen",
	["Rich Thorium Vein"] = "Reiches Thoriumvorkommen",
	["Ooze Covered Rich Thorium Vein"] = "Br\195\188hschlammbedecktes reiches Thoriumvorkommen",
	["Dark Iron Deposit"] = "Dunkeleisenablagerung",
  ["Lesser Bloodstone Deposit"] = "Geringe Blutsteinablagerung",
	["Incendicite Mineral Vein"] = "Pyrophor-Mineralvorkommen",
	-- tbc
	["Fel Iron Deposit"] = "Teufelseisenvorkommen",
	["Adamantite Deposit"] = "Adamantitablagerung",
	["Rich Adamantite Deposit"] = "Reiche Adamantitablagerung", -- check
	["Khorium Vein"] = "Khoriumvorkommen",

} end)

L:RegisterTranslations("frFR", function() return {
	["Filter"] = "Filtrer",
	["Filter out minerals"] = "Filtrer les minerais",

	["Module description"] = "Notes de minage pour Cartographer (bas\195\169 sur PinPoint par Ammo)",

	["Select all"] = "Tout s\195\169lectionner",
	["Select none"] = "Ne rien s\195\169lectionner",
	["Icon alpha"] = "Transparence des ic\195\180nes",
	["Alpha transparency of the icon"] = "D\195\169termine la transparence des ic\195\180nes.",
	["Icon size"] = "Taille des ic\195\180nes",
	["Size of the icons on the map"] = "D\195\169termine la taille des ic\195\180nes sur la carte.",
	["Show minimap icons"] = "Afficher les ic\195\180nes sur la minicarte",
	["Show mining icons on the minimap"] = "Affiche les ic\195\180nes des mines sur la minicarte.",

	["Copper"] = "Cuivre",
	["Tin"] = "Etain",
	["Iron"] = "Fer",
	["Silver"] = "Argent",
	["Gold"] = "Or",
	["Mithril"] = "Mithril",
	["Truesilver"] = "Vrai-argent",
	["Thorium"] = "Thorium",
	["Rich Thorium"] = "Thorium riche",
	["Dark Iron"] = "Sombrefer",
	["Lesser Bloodstone"] = "Pierre de sang inf\195\169rieure",
	["Incendicite"] = "Incendicite",
	["Indurium"] = "Indurium",
	-- tbc
	["Fel Iron"] = "Gangrefer",
	["Adamantite"] = "Adamantite",
	["Rich Adamantite"] = "Adamantite riche",
	["Khorium"] = "Khorium",

	["Copper Vein"] = "Filon de cuivre",
	["Tin Vein"] = "Filon d'\195\169tain",
	["Iron Deposit"] = "Gisement de fer",
	["Silver Vein"] = "Filon d'argent",
	["Ooze Covered Silver Vein"] = "Filon d'argent couvert de limon",
	["Gold Vein"] = "Filon d'or",
	["Ooze Covered Gold Vein"] = "Filon d'or couvert de limon",
	["Mithril Deposit"] = "Gisement de mithril",
	["Ooze Covered Mithril Deposit"] = "Gisement de mithril couvert de vase",
	["Truesilver Deposit"] = "Gisement de vrai-argent",
	["Ooze Covered Truesilver Deposit"] = "Gisement de vrai-argent couvert de vase",
	["Small Thorium Vein"] = "Petit filon de thorium",
	["Ooze Covered Thorium Vein"] = "Filon de thorium couvert de limon",
	["Hakkari Thorium Vein"] = "Filon de thorium Hakkari",
	["Rich Thorium Vein"] = "Riche filon de thorium",
	["Ooze Covered Rich Thorium Vein"] = "Riche filon de thorium couvert de limon",
	["Dark Iron Deposit"] = "Gisement de sombrefer",
	["Lesser Bloodstone Deposit"] = "Gisement de pierre de sang inférieure",
	["Incendicite Mineral Vein"] = "Filon d'incendicite",
	["Indurium Mineral Vein"] = "Filon d'indurium",
	-- tbc
	["Fel Iron Deposit"] = "Gisement de gangrefer",
	["Adamantite Deposit"] = "Gisement d'adamantite",
	["Rich Adamantite Deposit"] = "Riche gisement d'adamantite",
	["Khorium Vein"] = "Filon de khorium",
} end)

L:RegisterTranslations("esES", function() return {
	["Filter"] = "Filtro",
	["Filter out minerals"] = "Filtrar minerales",

  ["Module description"] = "Notas de mapa de Miner\195\173a para Cartographer (basado en PinPoint por Ammo)",

	["Select all"] = "Seleccionar todo",
	["Select none"] = "No seleccionar nada",
	["Icon alpha"] = "Transparencia de icono",
	["Alpha transparency of the icon"] = "Transparencia de los iconos",
	["Icon size"] = "Tama\195\177o de icono",
	["Size of the icons on the map"] = "Tama\195\177o de los iconos en el mapa",
        ["Show minimap icons"] = "Mostrar iconos en minimapa",
        ["Show mining icons on the minimap"] = "Muestra los iconos de miner\195\173a en el minimapa",

	["Copper"] = "Cobre",
	["Tin"] = "Esta\195\177o",
	["Iron"] = "Hierro",
	["Silver"] = "Plata",
	["Gold"] = "Oro",
	["Mithril"] = "Mitril",
	["Truesilver"] = "Veraplata",
	["Thorium"] = "Torio",
	["Rich Thorium"] = "Torio enriquecido",  -- check
	["Dark Iron"] = "Hierro negro",
	["Lesser Bloodstone"] = "Sangrita inferior",
	["Incendicite"] = "Incendicita",
	["Indurium"] = "Indurio",
	-- tbc
	["Fel Iron"] = "Hierro vil",
	["Adamantite"] = "Adamantita",
	["Rich Adamantite"] = "Adamantita enriquecida",  -- check
	["Khorium"] = "Khorium",   -- check

	["Copper Vein"] = "Fil\195\179n de cobre",
	["Tin Vein"] = "Fil\195\179n de esta\195\177o",
	["Iron Deposit"] = "Dep\195\179sito de hierro",
	["Silver Vein"] = "Fil\195\179n de plata",
	["Ooze Covered Silver Vein"] = "Fil\195\179n de plata cubierta de moco", -- check
	["Gold Vein"] = "Fil\195\179n de oro",
	["Ooze Covered Gold Vein"] = "Fil\195\179n de oro cubierta de moco",  -- check
	["Mithril Deposit"] = "Dep\195\179sito de mitril",
	["Ooze Covered Mithril Deposit"] = "Fil\195\179n de mitril cubierta de moco",  -- check
	["Truesilver Deposit"] = "Dep\195\179sito de veraplata",
	["Ooze Covered Truesilver Deposit"] = "Fil\195\179n de veraplata cubierta de moco",  -- check
	["Small Thorium Vein"] = "Fil\195\179n peque\195\177a de torio", -- check
	["Ooze Covered Thorium Vein"] = "Fil\195\179n de torio cubierta de moco",  -- check,
	["Hakkari Thorium Vein"] = "Fil\195\179n de torio hakkari",  -- check
	["Rich Thorium Vein"] = "Fil\195\179n de torio enriquecido",
	["Ooze Covered Rich Thorium Vein"] = "Fil\195\179n de torio enriquecido cubierta de moco",  -- check,
	["Dark Iron Deposit"] = "Dep\195\179sito de hierro negro",
	["Lesser Bloodstone Deposit"] = "Dep\195\179sito desangrita inferior",
	["Incendicite Mineral Vein"] = "Fil\195\179n de mineral de incendicita",   -- check
	["Indurium Mineral Vein"] = "Fil\195\179n de mineral de indurio",   -- check
	-- tbc
	["Fel Iron Deposit"] = "Dep\195\179sito de hierro vil",
	["Adamantite Deposit"] = "Dep\195\179sito de adamantita",
	["Rich Adamantite Deposit"] = "Dep\195\179sito de adamantita enriquecida",
	["Khorium Vein"] = "Fil\195\179n de khorium",  -- check
} end)

L:RegisterTranslations("koKR", function() return {
	["Filter"] = "필터링",
	["Filter out minerals"] = "광맥에 따라서 지도에 표시 여부를 선택합니다.",

  ["Module description"] = "맵노트에 채광(광맥)을 표시합니다.",

	["Select all"] = "모두 선택",
	["Select none"] = "선택 해제",
	["Icon alpha"] = "아이콘 투명도",
	["Alpha transparency of the icon"] = "아이콘의 투명도를 조절합니다.",
	["Icon size"] = "아이콘 크기",
	["Size of the icons on the map"] = "아이콘의 크기를 조절합니다.",
	["Show minimap icons"] = "미니맵 아이콘 보기",
	["Show mining icons on the minimap"] = "미니맵에 광맥 아이콘을 표시합니다.",

	["Copper"] = "구리",
	["Tin"] = "주석",
	["Iron"] = "철",
	["Silver"] = "은",
	["Gold"] = "금",
	["Mithril"] = "미스릴",
	["Truesilver"] = "진은",
	["Thorium"] = "토륨",
	["Rich Thorium"] = "풍부한 토륨",
	["Dark Iron"] = "검은무쇠",
	["Lesser Bloodstone"] = "저급 혈석",
	["Incendicite"] = "발연",
	["Indurium"] = "인듀리움",
	["Fel Iron"] = "지옥무쇠",
	["Adamantite"] = "아다만타이트",
	["Rich Adamantite"] = "풍부한 아다만타이트",
	["Khorium"] = "코륨",

	["Copper Vein"] = "구리 광맥",
	["Tin Vein"] = "주석 광맥",
	["Iron Deposit"] = "철 광맥",
	["Silver Vein"] = "은 광맥",
	["Ooze Covered Silver Vein"] = "진흙으로 덮인 은 광맥",
	["Gold Vein"] = "금 광맥",
	["Ooze Covered Gold Vein"] = "진흙으로 덮인 금 광맥",
	["Mithril Deposit"] = "미스릴 광맥",
	["Ooze Covered Mithril Deposit"] = "진흙으로 덮인 미스릴 광맥",
	["Truesilver Deposit"] = "진은 광맥",
	["Ooze Covered Truesilver Deposit"] = "진흙으로 덮인 진은 광맥",
	["Small Thorium Vein"] = "작은 토륨 광맥",
	["Ooze Covered Thorium Vein"] = "진흙으로 덮인 토륨 광맥",
	["Hakkari Thorium Vein"] = "학카리 토륨 광맥",
	["Rich Thorium Vein"] = "풍부한 토륨 광맥",
	["Ooze Covered Rich Thorium Vein"] = "진흙으로 덮인 풍부한 토륨 광맥",
	["Dark Iron Deposit"] = "검은무쇠 광맥",
	["Indurium Mineral Vein"] = "인듀리움 광맥",
	-- tbc
	["Fel Iron Deposit"] = "지옥무쇠 광맥",
	["Adamantite Deposit"] = "아다만타이트 광맥",
	["Rich Adamantite Deposit"] = "풍부한 아다만타이트 광맥",
	["Khorium Vein"] = "코륨 광맥",
} end)

L:RegisterTranslations("zhTW", function() return {
	["Filter"] = "篩檢",
	["Filter out minerals"] = "篩檢礦石",

	["Select all"] = "全部選擇",
	["Select none"] = "全部取消",

	["Copper"] = "銅",
	["Tin"] = "錫",
	["Iron"] = "鐵",
	["Silver"] = "銀",
	["Gold"] = "金",
 	["Mithril"] = "祕銀",
	["Truesilver"] = "真銀",
	["Thorium"] = "瑟銀",
	["Rich Thorium"] = "富瑟銀",
	["Dark Iron"] = "黑鐵",
	-- tbc
	--["Fel Iron"] = true,
	--["Adamantite"] = true,
	--["Rich Adamantite"] = true,
	--["Khorium"] = true,

	["Copper Vein"] = "銅礦",
	["Tin Vein"] = "錫礦",
	["Iron Deposit"] = "鐵礦石",
	["Silver Vein"] = "銀礦",
	["Ooze Covered Silver Vein"] = "軟泥覆蓋的銀礦",
	["Gold Vein"] = "金礦",
	["Ooze Covered Gold Vein"] = "軟泥覆蓋的金礦",
	["Mithril Deposit"] = "祕銀礦脈",
	["Ooze Covered Mithril Deposit"] = "軟泥覆蓋的祕銀礦脈",
	["Truesilver Deposit"] = "真銀礦石",
	["Ooze Covered Truesilver Deposit"] = "軟泥覆蓋的真銀礦石",
	["Small Thorium Vein"] = "瑟銀礦",
	["Ooze Covered Thorium Vein"] = "軟泥覆蓋的瑟銀礦",
	["Hakkari Thorium Vein"] = "哈卡萊瑟銀礦",
	["Rich Thorium Vein"] = "富瑟銀礦",
	["Ooze Covered Rich Thorium Vein"] = "軟泥覆蓋的富瑟銀礦",
	["Dark Iron Deposit"] = "黑鐵礦脈",
	-- tbc
--	["Fel Iron Deposit"] = true,
--	["Adamantite Deposit"] = true,
--	["Rich Adamantite Deposit"] = true,
--	["Khorium Vein"] = true,

} end)

L:RegisterTranslations("zhCN", function() return {
--	["Filter"] = true,
--	["Filter out minerals"] = true,

--	["Select all"] = true,
--	["Select none"] = true,

--	["Copper"] = true,
--	["Tin"] = true,
--	["Iron"] = true,
--	["Silver"] = true,
--	["Gold"] = true,
--	["Mithril"] = true,
--	["Truesilver"] = true,
--	["Thorium"] = true,
--	["Rich Thorium"] = true,
--	["Dark Iron"] = true,
--	["Fel Iron"] = true,
--	["Adamantite"] = true,
--	["Rich Adamantite"] = true,
--	["Khorium"] = true,

	["Copper Vein"] = "??",
	["Tin Vein"] = "??",
	["Iron Deposit"] = "??石",
	["Silver Vein"] = "??",
--	["Ooze Covered Silver Vein"] = true,
--	["Gold Vein"] = true,
--	["Ooze Covered Gold Vein"] = true,
	["Mithril Deposit"] = "秘???",
--	["Ooze Covered Mithril Deposit"] = true,
	["Truesilver Deposit"] = "???石",
--	["Ooze Covered Truesilver Deposit"] = true,
	["Small Thorium Vein"] = "瑟???",
--	["Ooze Covered Thorium Vein"] = true,
	["Hakkari Thorium Vein"] = "哈??瑟???",
	["Rich Thorium Vein"] = "富瑟??",
--	["Ooze Covered Rich Thorium Vein"] = true,
--	["Dark Iron Deposit"] = true,
--	["Fel Iron Deposit"] = true,
} end)

local mod = Cartographer:NewModule("Mining", "AceConsole-2.0", "AceEvent-2.0")

mod.icon = {
	["Copper"] = {
		text = L["Copper"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Ore_Copper_01",
		width = 14,
		height = 14
	},
	["Tin"] = {
		text = L["Tin"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Ore_Tin_01",
		width = 14,
		height = 14
	},
	["Silver"] = {
		text = L["Silver"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Stone_16",
		width = 14,
		height = 14
	},
	["Iron"] = {
		text = L["Iron"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Ore_Iron_01",
		width = 14,
		height = 14
	},
	["Gold"] = {
		text = L["Gold"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Ore_Gold_01",
		width = 14,
		height = 14
	},
	["Mithril"] = {
		text = L["Mithril"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Ore_Mithril_02",
		width = 14,
		height = 14
	},
	["Truesilver"] = {
		text = L["Truesilver"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Ore_TrueSilver_01",
		width = 14,
		height = 14
	},
	["Thorium"] = {
		text = L["Thorium"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Ore_Thorium_02",
		width = 14,
		height = 14
	},
	["Rich Thorium"] = {
		text = L["Rich Thorium"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Ore_RichThorium_01",
		width = 14,
		height = 14
	},
	["Dark Iron"] = {
		text = L["Dark Iron"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Ore_Mithril_01",
		width = 14,
		height = 14
	},
	["Indurium"] = {
		text = L["Indurium"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Ore_Mithril_01",
		width = 14,
		height = 14		
	},
	["Lesser Bloodstone"] = {
		text = L["Lesser Bloodstone"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Ore_Thorium_01",
		width = 14,
		height = 14
	},
	["Incendicite"] = {
		text = L["Incendicite"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Ore_Thorium_01",
		width = 14,
		height = 14
	},
	["Fel Iron"] = {
		text = L["Fel Iron"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Ore_FelIron",
		width = 14,
		height = 14
	},
	["Adamantite"] = {
		text = L["Adamantite"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Ore_Adamantium",
		width = 14,
		height = 14
	},
	["Rich Adamantite"] = {
		text = L["Rich Adamantite"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Ore_Adamantium_01",
		width = 14,
		height = 14
	},
	["Khorium"] = {
		text = L["Khorium"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Ore_Khorium",
		width = 14,
		height = 14
	},
}

function mod:OnInitialize()
	self.db = Cartographer:AcquireDBNamespace("Mining")
	Cartographer:RegisterDefaults("Mining", "profile", {
		filter = {
			['*'] = true,
		},
		iconAlpha = 1,
		iconScale = 1,
		minicons = true,
		
	})

	local aceopts = {}
	aceopts.toggle = {
		name = AceLibrary("AceLocale-2.2"):new("Cartographer")["Enabled"],
		desc = AceLibrary("AceLocale-2.2"):new("Cartographer")["Suspend/resume this module."],
		type  = 'toggle',
		order = -1,
		get   = function() return Cartographer:IsModuleActive(self) end,
		set   = function() Cartographer:ToggleModuleActive(self) end,
	}
	aceopts.trans = {
		name = L["Icon alpha"],
		desc = L["Alpha transparency of the icon"],
		type = 'range',
		min = 0.1,
		max = 1,
		step = 0.05,
		isPercent = true,
		get = "GetIconAlpha",
		set = "SetIconAlpha",
		order = 1
	}
	aceopts.scal = {
		name = L["Icon size"],
		desc = L["Size of the icons on the map"],
		type = 'range',
		min = 0.5,
		max = 2,
		step = 0.05,
		isPercent = true,
		get = "GetIconScale",
		set = "SetIconScale",
		order = 1
	}
	aceopts.minicons = {
		name = L["Show minimap icons"],
		desc = L["Show mining icons on the minimap"],
		type = 'toggle',
		set = "ToggleShowingMinimapIcons",
		get = "IsShowingMinimapIcons",
		order = 1,
	}

	aceopts.filter = {
		name = L["Filter"],
		desc = L["Filter out minerals"],
		type = 'group',
		args = {
			all = {
				name = L["Select all"],
				desc = L["Select all"],
				type = 'execute',
				func = function()
					for k in pairs(self.icon) do
						self:ToggleShowingMineral(k, true)
					end
				end,
				order = 1,
			},
			none = {
				name = L["Select none"],
				desc = L["Select none"],
				type = 'execute',
				func = function()
					for k in pairs(self.icon) do
						self:ToggleShowingMineral(k, false)
					end
				end,
				order = 2,
			},
			blank = {
				type = 'header',
				order = 3,
			}
		}
	}
	for k,v in pairs(self.icon) do
		local k = k
		aceopts.filter.args[k] = {
			name = v.text,
			desc = v.text,
			type = 'toggle',
			get = function()
				return self:IsShowingMineral(k)
			end,
			set = function(value)
				return self:ToggleShowingMineral(k, value)
			end,
		}
	end

	Cartographer.options.args["Mining"] = {
		name = bs["Mining"],
		desc = L["Module description"],
		type = 'group',
		args = aceopts,
		handler = self,
	}
	Cartographer:GetModule('Professions').addons[bs["Mining"]] = self
	AceLibrary("AceConsole-2.0"):InjectAceOptionsTable(self, Cartographer.options.args["Mining"])

	if not Cartographer_MiningDB then
		Cartographer_MiningDB = {}
	else
		for _, zone in pairs(Cartographer_MiningDB) do
			if type(zone) == "table" then
				for id, data in pairs(zone) do
					if data == "Small Thorium" then
						data = "Thorium"
						zone[id] = data
					end
				end
			end
		end
	end
end

function mod:OnEnable()
	if Cartographer_Notes then
		if not self.iconsregistered then
			for k,v in pairs(self.icon) do
				Cartographer_Notes:RegisterIcon(k, v)
			end
			self.iconsregistered = true
		end

		Cartographer_Notes:RegisterNotesDatabase('Mining', Cartographer_MiningDB, self)
	else
		Cartographer:ToggleModuleActive(self, false)
	end

	self:RegisterEvent("UI_ERROR_MESSAGE")

	self:RegisterEvent("CHAT_MSG_SPELL_SELF_BUFF")
end

function mod:OnDisable()
	self:UnregisterAllEvents()

	if Cartographer_Notes then
		Cartographer_Notes:UnregisterNotesDatabase('Mining')
	end
end

function mod:SetNote(what)
	local x, y = GetPlayerMapPosition("player")
	if x == 0 and y == 0 then return end
	local zone = GetRealZoneText()
	for zone, x_p, y_p, icon, creator, data in Cartographer_Notes:IterateNearbyNotes(zone, x, y, 8, "Mining", nil, true) do
		if icon == what then
			Cartographer_Notes:DeleteNote(zone, x_p, y_p)
		end
	end
	Cartographer_Notes:SetNote(zone, x, y, what, "Mining")
end

function mod:OnNoteTooltipRequest(zone, id, mineral, minimap)
	Tablet:SetTitle(L[mineral])
	Tablet:SetTitleColor(0, 0.8, 0)

	if Cartographer_Notes:IsShowingCreator() and not minimap then
		Tablet:AddCategory(
			'columns', 2,
			'hideBlankLine', true
		):AddLine(
			'text', AceLibrary("AceLocale-2.2"):new("Cartographer-Notes")["Created by"],
			'text2', bs["Mining"]
		)
	end
end

local t = {
	[L["Copper Vein"]] = "Copper",
	[L["Tin Vein"]] = "Tin",
	[L["Iron Deposit"]] = "Iron",
	[L["Silver Vein"]] = "Silver",
	[L["Ooze Covered Silver Vein"]] = "Silver",
	[L["Gold Vein"]] = "Gold",
	[L["Ooze Covered Gold Vein"]] = "Gold",
	[L["Mithril Deposit"]] = "Mithril",
	[L["Ooze Covered Mithril Deposit"]] = "Mithril",
	[L["Truesilver Deposit"]] = "Truesilver",
	[L["Ooze Covered Truesilver Deposit"]] = "Truesilver",
	[L["Small Thorium Vein"]] = "Thorium",
	[L["Ooze Covered Thorium Vein"]] = "Thorium",
	[L["Hakkari Thorium Vein"]] = "Thorium",
	[L["Rich Thorium Vein"]] = "Rich Thorium",
	[L["Ooze Covered Rich Thorium Vein"]] = "Rich Thorium",
	[L["Dark Iron Deposit"]] = "Dark Iron",
	[L["Lesser Bloodstone Deposit"]] = "Lesser Bloodstone",
	[L["Incendicite Mineral Vein"]] = "Incendicite",
	-- tbc
	[L["Fel Iron Deposit"]] = "Fel Iron",
	[L["Adamantite Deposit"]] = "Adamantite",
	[L["Rich Adamantite Deposit"]] = "Rich Adamantite",
	[L["Khorium Vein"]] = "Khorium",
}

function mod:RegisterOre(what)
	if what and what:len() > 0 then
		what = what:gsub("^(.-) %(%d+%)$", "%1")
		local mineral = t[what]
		if mineral then
			self:SetNote(mineral)
		end
	end
end

local perform_string = '^' .. (SIMPLEPERFORMSELFOTHER:format(bs["Mining"], "%s"):gsub("([%(%)%.%*%+%-%[%]%?%^%$%%])", "%%%1"):gsub("%%%%s", "(.+)")) .. '$'
function mod:CHAT_MSG_SPELL_SELF_BUFF(msg)
	local what = msg:match(perform_string)
	if what then
		self:RegisterOre(what)
	end
end

function mod:UI_ERROR_MESSAGE(msg)
	if msg:find(UNIT_SKINNABLE_ROCK) then
		self:RegisterOre(GameTooltipTextLeft1:GetText())
	end
end

function mod:IsNoteHidden(zone, id, mineral)
	return not self.db.profile.filter[mineral]
end

function mod:IsShowingMineral(mineral)
	return self.db.profile.filter[mineral]
end

function mod:ToggleShowingMineral(mineral, value)
	if value == nil then
		value = not self.db.profile.filter[mineral]
	end
	self.db.profile.filter[mineral] = value

	Cartographer_Notes:RefreshMap()
end
function mod:GetIconScale()
	return self.db.profile.iconScale
end

function mod:SetIconScale(value)
	self.db.profile.iconScale = value
	Cartographer_Notes:RefreshMap()
end
function mod:GetIconAlpha()
	return self.db.profile.iconAlpha
end

function mod:SetIconAlpha(value)
	self.db.profile.iconAlpha = value
	Cartographer_Notes:RefreshMap()
end

function mod:GetNoteTransparency(zone,id,data)
	return self.db.profile.iconAlpha
end
function mod:GetNoteScaling(zone,id,data)
	return self.db.profile.iconScale
end
function mod:IsShowingMinimapIcons()
	return self.db.profile.minicons
end
function mod:ToggleShowingMinimapIcons()
	self.db.profile.minicons = not self.db.profile.minicons
end
function mod:IsMiniNoteHidden(zone,id,data)
	return not self.db.profile.minicons
end
